package com.jiuqi.util.tree;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;

/* loaded from: com_jiuqi_util_tree.jar:com/jiuqi/util/tree/FastTreeBuilder.class */
public abstract class FastTreeBuilder implements TreeBuilder {
    protected ObjectVistor visitor;

    protected abstract String getObjectCode(Object obj);

    protected abstract String getObjectParent(Object obj);

    public FastTreeBuilder(ObjectVistor visitor) {
        this.visitor = visitor;
    }

    @Override // com.jiuqi.util.tree.TreeBuilder
    public TreeNode build(Iterator iterator) {
        List allNodes = new ArrayList();
        HashMap nodeFinder = new HashMap();
        while (iterator.hasNext()) {
            Object item = iterator.next();
            TreeNode node = new TreeNode(item);
            allNodes.add(node);
            nodeFinder.put(getObjectCode(item), node);
        }
        TreeNode root = new TreeNode();
        HashSet paths = new HashSet();
        for (int i = 0; i < allNodes.size(); i++) {
            TreeNode node2 = (TreeNode) allNodes.get(i);
            if (node2.getParent() == null) {
                paths.clear();
                while (true) {
                    paths.add(getObjectCode(node2.getItem()));
                    TreeNode parent = (TreeNode) nodeFinder.get(getObjectParent(node2.getItem()));
                    if (parent == null || paths.contains(getObjectCode(parent.getItem()))) {
                        break;
                    }
                    node2.setParent(parent);
                    node2 = parent;
                }
                TreeNode node3 = (TreeNode) allNodes.get(i);
                if (node3.getParent() == null) {
                    node3.setParent(root);
                }
            }
        }
        return root;
    }
}
